window.resizeTo(400,400);
list=[];

function safe_name(name){
	return(name.replace(/[^ ()+,-.;=@^_`{}0-9A-Za-zN}L~---σ-քF@-v]\efghdc񁌁T-]@-I-ˁ́́݁΁ށ-ځa-臓߁⁼ۇ܇@-S---@-VX-l-J-U@-E-S-ei`cakjdlfn_mbgh~-rso-qut-II-`-]/g,'_'));
}

function run(cmd){
	(new ActiveXObject('WScript.Shell')).Run(cmd);
}

function load(n,code){
	var s;
	with(new ActiveXObject("ADODB.Stream")){
		Charset=(arguments.length>1)?(code?code:'_autodetect'):'utf-8';
		Open();
		loadFromFile(n);
		s=ReadText();
		Close();
	}
	return(s);
}
function save(str,n,code){
	with(new ActiveXObject("ADODB.Stream")){
		Charset=(arguments.length>2)?code:'utf-8';
		Open();
		WriteText(str);
		saveToFile(n,2);
		Close();
	}
}
function fromJSON(str){
	var __FROM_JSON_TEMP__;
	eval((''+str).replace(/^\s*/,'__FROM_JSON_TEMP__=')+';');
	return(__FROM_JSON_TEMP__);
}
function toJSON(obj){
	switch(typeof(obj)){
		case('object'):{
			if(obj==null){
				return('null');
			}else if(obj instanceof Array){
				var res=new Array;
				for(var i in obj){
					res.push(toJSON(obj[i]));
				}
				return('[\n'+res.join(',\n')+'\n]');
			}else{
				var res=new Array;
				for(var i in obj){
					res.push(toJSON(i)+':'+toJSON(obj[i]));
				}
				return('{\n'+res.join(',\n')+'\n}');
			}
		}case('boolean'):case('number'):{
			return(obj.toString());
		}case('function'):{
			return(obj.toString().replace(/\{\n +\[native code\]\n}$/,"{}"));
		}case('string'):{
			return('"'+obj.replace(/\\/g,"\\\\").replace(/[\n\r"]/g,function($1){switch($1){
					case("\n"):{return("\\n");}
					case("\r"):{return("\\r");}
					case('"'):{return('\\"');}
				}})+'"');
		}
	}
}
function loadJSON(name){
	return(fromJSON(load(name,'_autodetect')));
}
function saveJSON(obj,file){
	save(toJSON(obj),file);
}


function parseCommandLine(str){
	var res=str.match(/(".+?("|$)|[^ @]+)/g);
	if(res){
		for(var i=0;i<res.length;i++){
			res[i]=res[i].replace(/^\+/,'').replace(/^"(.*)"$/,'$1');
		}
	}
	return(res);
}


function showHelp(){
	$('TemplateDescription').update(loadJSON(basedir+"templates\\"+get_template()+".js").description||"[no help]");
}


function load_template(){
	var fso=new ActiveXObject("Scripting.FileSystemObject");
	var dir=fso.GetFolder(basedir+"templates");
	for(var e=new Enumerator(dir.Files);!e.atEnd();e.moveNext()){
		var n=e.item().Name;
		if(n.match(/\.js$/)){
			add_template(n.replace(/\.js$/,""));
		}
	}
	
}
function add_template(n,text){
	var e=document.createElement("option");
	var sel=document.getElementById("Template");
	e.value=n;
	e.innerHTML=text||n;
	sel.appendChild(e);
}


function edit_template(){
	run(Config.EditorCommand.replace(/%Path%/,basedir+'templates\\'+get_template()+'.js'));
}

function open_template_url(){
	alert(basedir+'template\\'+get_template()+'.js');
	var url=loadJSON(basedir+'templates\\'+get_template()+'.js').BaseURL;
	if(url){
		run(url);
	}else{
		alert("{URL`Ă܂");
	}
}


function get_template(){
	return(document.getElementById('Template').value);
}

function get_url(){
	return(document.getElementById('URL').value);
}

function get_name(){
	return(document.getElementById('Name').value);
}

function load_list(){
	var fso=new ActiveXObject("Scripting.FileSystemObject");
	var dir=fso.GetFolder(basedir+"crawls");
	for(var e=new Enumerator(dir.Files);!e.atEnd();e.moveNext()){
		var n=e.item().Name;
		if(n.match(/\.js$/)){
			list.push(n.replace(/\.js$/,""));
		}
	}
}

function add_list(){
	var template=get_template();
	var url=get_url();
	var name=safe_name(get_name()||url);
	
	var txt=load(basedir+"templates\\"+template+'.js','_autodetect');
	txt=txt.replace(/StartURL:''/,"StartURL:'"+url+"'");
	save(txt,basedir+'crawls\\'+name+'.js');
	list.push(name);
	show_list();
}
function show_list(){
	var html=[];
	if(list.length==0){
		html=['ev[gIURL͂Au`쐬vĂ'];
	}else{
		for(var i=0;i<list.length;i++){
			if(list[i]){
				html.push('<li class="Item">'+list[i]+'<br /><input type="button" value="폜" onclick="remove_list('+i+')" /><input type="button" value="ҏW" onclick="edit_list('+i+')" /><input type="button" value="URLJ" onclick="open_url('+i+')" /><input type="button" value="PƏ" onclick="crawl_single('+i+')" /></li>');
			}
		}
	}
	document.getElementById('List').innerHTML=html.join('');
}



function remove_list(i){
	file_delete(list[i]);
	delete(list[i]);
	show_list();
}
function edit_list(i){
	run(Config.EditorCommand.replace(/%Path%/,basedir+'crawls\\'+list[i]+'.js'));
}
function open_url(i){
	run(loadJSON(basedir+'crawls\\'+list[i]+'.js').StartURL);
}
function crawl_single(i){
	var c='cscript //NoLogo "'+basedir+'crawl.js" "'+list[i]+'"';
	if(document.getElementById('ShowWindow').checked){
		c='cmd /k '+c;
	}
	run(c);
}
function edit_config(){
	run(Config.EditorCommand.replace(/%Path%/,basedir+'config.js'));
}

function show_readme(){
	run(Config.EditorCommand.replace(/%Path%/,basedir+'readme.txt'));
}


function execute(){
	var c='cscript //NoLogo "'+basedir+'crawl.js"';
	if(document.getElementById('ShowWindow').checked){
		c='cmd /k '+c;
	}
	run(c);
}




function init(){
	basedir=parseCommandLine(HTA.commandLine)[0].replace(/[^\\]*$/,'');
	Config=loadJSON(basedir+'config.js');
	try{load_template();}catch(e){}
	try{load_list();}catch(e){}
	try{show_list();}catch(e){}
	try{showHelp();}catch(e){}
}


