



Object.extend = function(destination, source) {
  for (var property in source)
    destination[property] = source[property];
  return destination;
};


RegExp.escape=function(str){return(String(str).replace(/(?=[.*+?^=!:${}()|[\]\/\\])/g,"\\"))};

Array.prototype.unique=function(){
	var res=[];
	var k={};
	for(var i=0;i<this.length;i++){
		if(!k[this[i]]){
			res.push(this[i]);
			k[this[i]]=true;
		}
	}
	return(res);
};




function load(n,code){
	var s;
	with(new ActiveXObject("ADODB.Stream")){
		Charset=(arguments.length>1)?(code?code:'_autodetect'):'utf-8';
		Open();
		loadFromFile(n);
		s=ReadText();
		Close();
	}
	return(s);
}
function save(str,n,code){
	with(new ActiveXObject("ADODB.Stream")){
		Charset=(arguments.length>2)?code:'utf-8';
		Open();
		WriteText(str);
		saveToFile(n,2);
		Close();
	}
}
function fromJSON(str){
	var __FROM_JSON_TEMP__;
	eval((''+str).replace(/^\s*/,'__FROM_JSON_TEMP__=')+';');
	return(__FROM_JSON_TEMP__);
}
function toJSON(obj){
	switch(typeof(obj)){
		case('object'):{
			if(obj==null){
				return('null');
			}else if(obj instanceof Array){
				var res=new Array;
				for(var i in obj){
					res.push(toJSON(obj[i]));
				}
				return('[\n'+res.join(',\n')+'\n]');
			}else{
				var res=new Array;
				for(var i in obj){
					res.push(toJSON(i)+':'+toJSON(obj[i]));
				}
				return('{\n'+res.join(',\n')+'\n}');
			}
		}case('boolean'):case('number'):{
			return(obj.toString());
		}case('function'):{
			return(obj.toString().replace(/\{\n +\[native code\]\n}$/,"{}"));
		}case('string'):{
			return('"'+obj.replace(/\\/g,"\\\\").replace(/[\n\r"]/g,function($1){switch($1){
					case("\n"):{return("\\n");}
					case("\r"):{return("\\r");}
					case('"'):{return('\\"');}
				}})+'"');
		}
	}
}
function loadJSON(name){
	try{
		return(fromJSON(load(name,'_autodetect')));
	}catch(e){
		try{
			return(fromJSON(load(name,'utf-8')));
		}catch(e){
			return(fromJSON(load(name,'sjis')));
		}
	}
}
function saveJSON(obj,file){
	save(toJSON(obj),file);
}

function safe_name(name){
	return(name.replace(/[^ ()+,-.;=@^_`{}0-9A-Za-zN}L~---σ-քF@-v]\efghdc񁌁T-]@-I-ˁ́́݁΁ށ-ځa-臓߁⁼ۇ܇@-S---@-VX-l-J-U@-E-S-ei`cakjdlfn_mbgh~-rso-qut-II-`-]/g,'_'));
}

function undup_name(path){
	if(file_exists(path) && path.match(/^(.*?)(\d*)(\.\w+)?$/)){
		var i=RegExp.$2||0;
		var base=RegExp.$1;
		var ext=RegExp.$3;
		i++;
		return(undup_name(base+i+ext));
	}else{
		return(path);
	}
}

function file_exists(path){
	var fso=(new ActiveXObject("Scripting.FileSystemObject"));
	return(fso.FileExists(path)||fso.FolderExists(path));
}



function mkdir(path){
	try{
		with((new ActiveXObject("Scripting.FileSystemObject"))){
			if(path.match(/^(.*)\\([^\\]*)\\?$/)){
				if(!FolderExists(RegExp.$1)){
					mkdir(RegExp.$1);
				}
				CreateFolder(path);
			}
		}
	}catch(e){
	}
}
function file_delete(path){
	try{
		with((new ActiveXObject("Scripting.FileSystemObject"))){
			if(FileExists(path)){
				GetFile(path).Delete();
			}
		}
	}catch(e){
	}
}

function echo(msg){
	if(WScript.FullName.indexOf('cscript')!=-1){
		WScript.echo(msg);
	}
}


$break={};$continue={};
function foreach(ary,func){
	for(var i=0;i<ary.length;i++){
		try{
			func(ary[i],i,ary);
		}catch(e){
			if(e==$break){
				break;
			}
		}
	}
}









function curl(options,workdir){
	//CURLɂHTTPANZXs
	var curl=basedir+"bin\\curl.exe";
	var cookie=basedir+"data\\cookie.txt";
	var cmd='"'+curl+'" -k -b "'+cookie+'" -c "'+cookie+'" -A "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)" -L '+options;
	var ws=new ActiveXObject("WScript.Shell");
	if(workdir){
		ws.CurrentDirectory=workdir;
	}
	ws.Run(cmd,0,true);
}
function curl_clear(){
	file_delete(basedir+"data\\cookie.txt");
	file_delete(basedir+"data\\tmp_html.txt");
}




function move_file(src,dest){
	var fso=new ActiveXObject("Scripting.FileSystemObject");
	fso.MoveFile(src,dest);
}




function decode_htmlspecialchars(str){
	var dict={'amp':'&','gt':'>','lt':'<','quot':'"','nbsp':' '};
	return(str.replace(/&([a-z]+);/,function($0,$1){
		return(dict[$1]||$0);
	}));
}

function build_url(baseurl,suburl){
	if(suburl.match(/^https?:/)){
		return(suburl);
	}else if(suburl.match(/^\//)){
		return(baseurl.replace(/(^http:\/\/[^/]*).*$/,"$1") + suburl);
	}else{
		var a=baseurl.replace(/^http:\/\/[^/]*\//,"").split("/");
		var b=suburl.split("/");
		var c=[];
		a.pop();
		a=a.concat(b);
		for(var i=0;i<a.length;i++){
			if(a[i]=='.'){
			}else if(a[i]=='..'){
				c.pop();
			}else{
				c.push(a[i]);
			}
		}
		return(baseurl.replace(/(^http:\/\/[^/]*\/).*$/,"$1") + c.join("/"));
	}
}


function url_domain(url){
	return(url.replace(/^.*\/\/(.*?)\/.*$/,'$1'));
}


function extract_links(url,referer){
}





function match(subject,rule){
	if(!(rule instanceof Array)){
		rule=[rule];
	}
	for(var i=0;i<rule.length;i++){
		if(typeof(rule[i])=='string'){
			if(subject.indexOf(rule[i])!=-1){
				return(true);
			}
		}else if(typeof(rule[i])=='function'){
			if(rule[i](subject)){
				return(true);
			}
		}else if(rule[i] instanceof RegExp){
			if(rule[i].test(subject)){
				return(true);
			}
		}
	}
	return(false);
}




function crawl(name){
	var site={
		LoginInfo:null,
		DownloadURL:[],
		NoDownloadURL:[],
		RecurseURL:[],
		NoRecurseURL:[],
		CheckNewURL:[],
		PagingURL:[],
		MaxRecurse:10,
		MaxRecurseExternalDomain:0,
		OldListCount:10000,
		UrlConversions:[],
		FileNamePattern:'%SaveDir%\\%CrawlName%\\%URLPath%\\%FileName%',
		
		prepare:function(){
			this.Login();
		},
		Login:function(){
			if(this.LoginInfo){
				var li=this.LoginInfo;
				var url=li.URL;
				if(li.Method.toLowerCase()=='post'){
					url='-d "'+li.Params+'" '+url;
				}else if(li.URL.match(/\?/)){
					url=url+'&'+li.Params;
				}else{
					url=url+'?'+li.Params;
				}
				curl('-e "'+li.FormURL+'" '+url);
			}
		},
		loadOldList:function(){
			mkdir(this.datadir);
			this.oldList={};	//oXg
			this.newList=[];	//oɂȂ郊Xg
			this.tmpList={};	//񏄉ς݂̃Xg
			this.pagingList={};	//SĊoy[WOURLXg
			//oXgꗗ
			var files=[];
			var fso=new ActiveXObject("Scripting.FileSystemObject");
			var dir=fso.GetFolder(this.datadir);
			for(var e=new Enumerator(dir.Files);!e.atEnd();e.moveNext()){
				if(e.item().Name.match(/_list.txt/)){
					files.push(e.item().Name);
				}
			}
			files.sort();
			//V̂K茏܂œǂݍ
			var c=0;
			for(var i=files.length-1;i>=0;i--){
				var list=load(this.datadir+files[i],'_autodetect').split(/[\n\r]+/);
				for(var j=0;j<list.length;j++){
					this.oldList[list[j]]=true;
					c++;
				}
				if(c>this.OldListCount){
					break;
				}
			}
		},
		saveOldList:function(){
			save(this.newList.join("\n"),this.datadir+(new Date).getTime()+"_list.txt",'Shift_JIS');
		},
		ExtractLinks:function(url,referer){
			return(this.ExtractLinksMain(url,referer));
		},
		GetHTML:function(url,referer){
			var file=basedir+"data\\tmp_html.txt";
			if(referer){
				curl('-o "'+file+'" -e '+referer+' '+url);
			}else{
				curl('-o "'+file+'" '+url);
			}
			var html=load(file,"_autodetect");
			if(html.match(/content="[^"]*charset=(.*?)"/i)){
				html=load(file,RegExp.$1);
			}
			return(html);
		},
		
		ReplaceHTML:function(html,url,referer){
			return(this.ReplaceHTMLMain(html,url,referer));
		},
		ReplaceHTMLMain:function(html,url,referer){
			var hdr="";
			if(html.match(/<head[^>]*>(,*?)<\/head>/i) || html.match(/^(.*?)<body/)){
				hdr=RegExp.$1;
				hdr=hdr.replace(/<meta [^>]*Content-Type[^>]*>/,'');
			}
			hdr='<script>window.open=function(url){if(url)document.write("<a href=\\""+url+"\\">"+url+"</a>");};'
				+'document.write=(function(orig){return(function(str){return(orig.call(document,str.replace(/<(img|frame|iframe|embed|object|param)(\s[^>]*)>/,"<a $2>")));})})(document.write);'
				+'window.'+('alert,close,confirm,execScript,focus,moveBy,moveTo,navigate,prompt,resizeBy,resizeTo,scroll,scrollBy,scrollTo,showHelp,showModalDialog'.split(/,/).join("=function(){};window."))+'=function(){}'
				+'</script>'+hdr;
			if(hdr.match(/<base [^>]*src=['"]?([^\s'"]+)/i)){
				baseurl=RegExp.$1;
			}else{
				hdr+='<base href="'+url+'" />';
			}
			
			//{̖̂ߍ݂폜
			var body=html.replace(/^.*(?=<body[^>]*>)|^.*<frameset[^>]*>|<\/body>.*$/ig,'');
			body=body.replace(/<((img|iframe|frame) [^>]*)>/gi,function($0,$1,$2){
				if($1.match(/src=['"]?([^\s'"]+)/i)){
					return('<a href="'+RegExp.$1+'">'+RegExp.$1+'</a>');
				}else{
					return('');
				}
			});
			body=body.replace(/<object[\s\S]*?<\/object>/ig,function($0){
				return($0.replace(/.*?<param [^>]*name=['"]movie[^>]*>/ig,function($0){
					if($0.match(/value=['"]?([^\s'"]+)/i)){
						return('<a href="'+RegExp.$1+'">'+RegExp.$1+'</a>');
					}else{
						return('');
					}
				}));
			});
			body=body.replace(/<embed [^>]*>/ig,function($0){
				if($0.match(/src=['"]?([^\s'"]+)/i)){
					return('<a href="'+RegExp.$1+'">'+RegExp.$1+'</a>');
				}else{
					return('');
				}
			});
			return(hdr+body);
		},
		ExtractLinksMain:function(url,referer){
			var urls=[];
			var found={};
			var baseurl=url.split(/ /).pop();
			var html=this.GetHTML(url,referer);
			var hf=new ActiveXObject('htmlfile');
			hf.open();
			hf.write(this.ReplaceHTML(html,url,referer));
			hf.close();
			
			//tH[ɂ郊No(󗓂̂ȂtH[̂)
			var inp=hf.getElementsByTagName('input');
			for(var i=0;i<inp.length;i++){
				if(inp[i].form){
					if(inp[i].value){
						if(inp[i].name){
							(inp[i].form.Params=(inp[i].form.Params||[])).push(inp[i].name+'='+encodeURIComponent(inp[i].value));
						}
					}else{
						inp[i].form.noFollow=true;
					}
				}
			}
			var ta=hf.getElementsByTagName('textarea');
			for(var i=0;i<ta.length;i++){
				if(ta[i].form){
					ta[i].form.noFollow=true;
				}
			}
			var frm=hf.getElementsByTagName('form');
			for(var i=0;i<frm.length;i++){
				if(!frm[i].noFollow){
					var url=build_url(baseurl,frm[i].action);
					var params=(frm[i].Params||[]).join('&');
					if(frm[i].method.toLowerCase()=='post'){
						url='-d "'+params+'" '+url;
					}else if(url.match(/\?/)){
						url=url+'&'+params;
					}else{
						url=url+'?'+params;
					}
					if(!found[url]){
						urls.push(url);
						found[url]=true;
					}
				}
			}
			//NƁAuꂽߍ݂URLo
			var l=hf.getElementsByTagName('a');
			for(var i=0;i<l.length;i++){
				var url=(l[i].href||l[i].src||'').replace(/#.*$/g,'');
				if(!found[url]){
					urls.push(url);
					found[url]=true;
				}
			}
			//ׂURLo
			hf.documentElement.innerHTML.replace(/h?(ttps?:\/\/[-_.!~*'()a-zA-Z0-9;/?:@&=+$,%#]+)/ig,function($0,$1){
				if(!found['h'+$1]){
					urls.push('h'+$1);
					found['h'+$1]=true;
				}
			});
			return(urls);
		},
		ConvertURL:function(url){
			return(url);
		},
		Recurse:function(){
			try{
				this.RecurseMain.apply(this,arguments);
			}catch(e){
				echo("y[WG[: "+(e.message||e));
			}
		},
		SplitPagedURL:function(url){
			var pu=this.PagingURL;
			var base,num;
			for(var i=0;i<pu.length;i++){
				if(typeof(pu[i])=='string'){
					if(url.indexOf(pu[i])!=-1){
						base=url.replace(new RegExp('^(.*?'+RegExp.escape(pu[i])+'.*?)(\\d+)(.*)$',''),function($0,$1,$2,$3){
							num=$2;
							return($1+$3);
						});
						return([base,num]);
					}
				}else if(typeof(pu[i])=='function'){
					var res=pu[i](url);
					if(res){
						return(res);
					}
				}else if(pu[i] instanceof RegExp){
					base=url.replace(pu[i],function($0){
						return($0.replace(/\d+/,function($$0){
							num=$$0;
							return('');
						}));
					});
					return([base,num]);
				}
			}
		},
		RecurseMain:function(url,referer,depth,ext){
			WScript.Sleep(this.Interval||200);
			echo("y[W: "+url);
			
			//oEõXgɒǉ
			if(match(url,this.CheckNewURL)){
				this.newList.push(url);
				this.oldList[url]=true;
			}
			this.tmpList[url]=true;
			
			//URLo
			url=this.ConvertURL(url);
			var urls=this.ExtractLinks(url,referer);
			var found_old=false;
			var ref=url.split(/ /).pop();
			
			//ɈvAołȂURL_E[h
			for(var i=0;i<urls.length;i++){
				if(match(urls[i],this.DownloadURL) && !match(urls[i],this.NoDownloadURL)){
					if(this.oldList[urls[i]]){
						found_old=true;
					}else{
						this.Download(urls[i],ref);
					}
				}
			}
			if(depth<this.MaxDepth){
				//ɈvAy[WOnłȂAołołȂURLH
				for(var i=0;i<urls.length;i++){
					if(match(urls[i],this.RecurseURL) && !match(urls[i],this.NoRecurseURL) && !match(urls[i],this.PagingURL)){
						if(match(urls[i],this.CheckNewURL) && this.oldList[urls[i]]){
							found_old=true;
							continue;
						}
						if(this.tmpList[urls[i]]){
							continue;
						}
						if(url_domain[url]!=url_domain[urls[i]]){
							echo(urls[i]);
							if(ext<this.MaxRecurseExternalDomain){
								this.Recurse(urls[i],ref,depth+1,ext+1);
							}else{
								continue;
							}
						}else{
							this.Recurse(urls[i],ref,depth+1,ext);
						}
					}
				}
			}
			//URLy[WOnŁAoɓBꍇAXgɒǉ
			if(match(url,this.PagingURL) && found_old){
				this.pagingList[this.SplitPagedURL(url)[0]]=true;
			}
			//łȂy[WOnURL(ԍ̎ႢURLH邽߁AUzɓ)
			var pagings={};
			for(var i=0;i<urls.length;i++){
				if(url_domain[url]!=url_domain[urls[i]] && ext>=this.MaxRecurseExternalDomain){
					continue;
				}
				if(match(urls[i],this.PagingURL) && !match(urls[i],this.NoRecurseURL)){
					var pair=this.SplitPagedURL(urls[i]);
					(pagings[pair[0]]||(pagings[pair[0]]=[]))[pair[1]]=urls[i];
				}
			}
			//y[WOnURLH
			for(var n in pagings){
				for(var i=0;i<pagings[n].length;i++){
					if(pagings[n][i] && !this.tmpList[pagings[n][i]] && !this.pagingList[n]){
						this.Recurse(pagings[n][i],ref,depth,ext);
					}
				}
			}
		},
		Download:function(url,referer){
			try{
				this.DownloadMain(url,referer);
				WScript.Sleep(this.DownloadInterval||400);
			}catch(e){
				echo("_E[hG[: "+(e.message||e));
			}
		},
		DownloadMain:function(url,referer){
			this.tmpList[url]=true;
			this.oldList[url]=true;
			this.newList.push(url);
			
			//O_E[_[
			var ed=Config.ExternalDownloaders;
			for(var i=0;i<ed.length;i++){
				if(match(url,ed[i].TargetURL)){
					echo("Oc[Ń_E[h: "+url);
					(new ActiveXObject("WScript.Shell")).Run(ed[i].Commandline.replace(/%URL%/,url.split(' ').pop()).replace(/%Referer%/,referer),1,false);
					return;
				}
			}
			//W_E[h
			echo("_E[h: "+url);
			//t@Cp[c̐
			var up='',fn='';
			var l=url.split(' ').pop().split('/');
			if(!l[l.length-1]){
				l.pop();
			}
			fn=safe_name(l.pop());
			for(var i=1;i<l.length;i++){
				if(l[i]){
					up+=safe_name(l[i])+"\\";
				}
			}
			
			//ۑ
			var file=this.FileNamePattern
				.replace(/%SaveDir%/,Config.SaveDir)
				.replace(/%CrawlName%/,this.name)
				.replace(/%URLPath%/,up)
				.replace(/%Path_Encoded%/,safe_name(encodeURIComponent(url)))
				.replace(/%FileName%/,fn);
			
			if(referer && !url.match(/-e /)){
				referer=' -e '+referer;
			}else{
				referer='';
				die;
			}
			//ۑs
			if(file.match(/\\$/)){
				mkdir(file);
				curl('-O "'+file+'"'+referer+' '+url);
			}else{
				mkdir(file.replace(/[^\\]+$/,''));
				curl('-o "'+file+'"'+referer+' '+url);
			}
		},
		execute:function(){
			echo(": "+this.name);
			this.loadOldList();
			this.prepare();
			this.Recurse(this.StartURL,null,0,0);
			this.saveOldList();
		}
	};
	try{
		Object.extend(site,loadJSON(name));
		site.name=name.replace(/^.*\\|\.js$/g,'');
		site.datadir=basedir+'data\\'+site.name+"\\";
	}catch(e){
		echo("`ǂݍ݃G[: "+(e.message||e));
	}
	if(site.datadir){
		site.execute();
	}
}

function crawl_all(){
	var fso=new ActiveXObject("Scripting.FileSystemObject");
	var dir=fso.GetFolder(basedir+"crawls");
	for(var e=new Enumerator(dir.Files);!e.atEnd();e.moveNext()){
		crawl(e.item().Path);
	}
}


function crawl_2ch(){
	echo("2chJn");
	Log.Crawl2ch=Log.Crawl2ch||{};
	var file=basedir+"data\\bbsmenu.html";
	curl('-o "'+file+'" '+Config.Crawl2ch.BBSMenu);
	var html=load(file,"_autodetect");
	
	var b=Config.Crawl2ch.Boards;
	for(var i=0;i<b.length;i++){
		var url='';
		if(b[i].BBS.match(/^http:\/\//)){
			url=b[i].BBS;
		}else{
			html.replace(new RegExp('<A HREF=(http://.*?/'+b[i].BBS+'/)>','i'),function($0,$1){
				url=$1;
			});
		}
		if(url){
			crawl_bbs(b[i].BBS,url,b[i].Keywords,b[i].IgnoreKeywords);
		}
	}
}


function crawl_bbs(bbs,url,keywords,ignore){
	echo('BBS: '+bbs);
	Log.Crawl2ch[bbs]=Log.Crawl2ch[bbs]||{};
	var file=basedir+"data\\tmp.html";
	curl('-A "Monazilla/1.00" -o "'+file+'" '+url+'subject.txt');
	load(file,"_autodetect").replace(/(\d+)\.dat<>(.*?)\s*\((\d+)\)[\n\r]+/ig,function($0,dat,title,count){
		if(match(title,keywords) && !match(title,ignore) &&  dat>1000000000){
			Log.Crawl2ch[bbs][dat]=Log.Crawl2ch[bbs][dat]||0;
			if((count-Log.Crawl2ch[bbs][dat])>=Config.Crawl2ch.MinCount){
				crawl_thread(bbs,url,title,dat,Log.Crawl2ch[bbs][dat]);
			}else{
				echo("Xbh: "+title +' (VXs)');
			}
		}
	});
	
}
function crawl_thread(bbs,url,title,dat,read){
	var bbsdir=Config.SaveDir+safe_name(bbs.replace(/^http:\/\//i))+"\\";
	var thdir=bbsdir+safe_name(title)+"\\";
	var file=bbsdir+dat+'.dat';
	mkdir(thdir);
	echo("Xbh: "+title);
	curl('-A "Monazilla/1.00" --output "'+file+'" --continue-at - '+url+'dat/'+dat+'.dat');
	var lines=load(file,'_autodetect').split(/[\n\r]+/);
	for(var i=0;i<lines.length;i++){
		if(i>=read){
			lines[i].replace(/h?(ttps?:\/\/[-_.!~*'()a-zA-Z0-9;/?:@&=+$,%#]+)/ig,function($0,$1){
				var url='h'+$1;
				if(match(url,Config.Crawl2ch.DownloadURL) && !match(url,Config.Crawl2ch.NoDownloadURL)){
					var ed=Config.ExternalDownloaders;
					for(var i=0;i<ed.length;i++){
						if(match(url,ed[i].TargetURL)){
							echo("Oc[Ń_E[h: "+url);
							(new ActiveXObject("WScript.Shell")).Run(ed[i].Commandline.replace(/%URL%/,url),1,false);
							return;
						}
					}
					var path=thdir+safe_name(url.replace(/^https?:\/\//i,''));
					if(!file_exists(path)){
						echo("_E[h: "+url);
						var referer=url.replace(/[^\/]*$/,'');
						curl('-o "'+path+'" -e '+referer+' '+url);
					}
				}
			});
		}
	}
	Log.Crawl2ch[bbs][dat]=i;
}




basedir=WScript.ScriptFullName.replace(/[^\\]+$/,"");

Config=Object.extend({
	Crawl2ch:{
		BBSMenu:'http://menu.2ch.net/bbsmenu.html',
		MinCount:10,
		Boards:[],
		DownloadURL:[],
		NoDownloadURL:[]
	},
	ExternalDownloaders:[]
},loadJSON(basedir+"config.js"));
if(!Config.SaveDir){
	Config.SaveDir=basedir+"downloads\\";
}
try{
	Log=loadJSON(basedir+'data\\log.js');
}catch(e){
	Log={};
}

if(WScript.Arguments.length>0){
	if(WScript.Arguments(0)=='2ch'){
		crawl_2ch();
	}else{
		crawl(basedir+"crawls\\"+WScript.Arguments(0)+'.js');
	}
}else{
	crawl_2ch();
	crawl_all();
	curl_clear()
}

saveJSON(Log,basedir+'data\\log.js');


